package com.bjlt.spider.controller;

import com.bjlt.spider.entity.AirSourceLineVo;
import com.bjlt.spider.entity.ExportAirSourceLineVo;
import com.google.common.collect.Lists;
import com.luyn.date.DatePattren;
import com.luyn.excel.ExcelExportUtil;
import com.luyn.web.RespEntity;
import lombok.extern.slf4j.Slf4j;
import org.apache.poi.ss.usermodel.Workbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Date;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

@RestController
@Slf4j
@RequestMapping(value = "/AirLine")
public class AirLine {
    @Autowired
    private RedisTemplate<String,Object> redisTemplate;

    @RequestMapping(value = "count", method = RequestMethod.GET)
    public RespEntity updateByPrimaryKeySelective(org.apache.catalina.servlet4preview.http.HttpServletRequest request,
                                                  HttpServletResponse response){

        response.setHeader("content-type", "application/octet-stream");
        response.setContentType("application/octet-stream");
        String fileName = com.luyn.date.DateUtil.getFormatDate(new Date(), DatePattren.DATA_FORMAT_14) + ".xls";
        response.setHeader("Content-Disposition", "attachment;filename=" + fileName);

        Set<String> keys = redisTemplate.keys("airsourceline*");

        List<ExportAirSourceLineVo> list = Lists.newArrayList();
        keys.forEach(f->{
            Set<AirSourceLineVo> airSourceLineVos1 = (Set<AirSourceLineVo>) redisTemplate.opsForValue().get(f);
            airSourceLineVos1.forEach(t->{
                log.info(t.toString());
                ExportAirSourceLineVo exportAirSourceLineVo = new ExportAirSourceLineVo();
                exportAirSourceLineVo.setAirSourceID(t.getAirSourceID());
                exportAirSourceLineVo.setFromCity(t.getFromCity());
                exportAirSourceLineVo.setToCity(t.getToCity());
                exportAirSourceLineVo.setFromCityZh(t.getFromCityZh());
                exportAirSourceLineVo.setToCityZh(t.getToCityZh());
                exportAirSourceLineVo.setFromCountry(t.getFromCountry());
                exportAirSourceLineVo.setStatus(t.getStatus());
                list.add(exportAirSourceLineVo);
            });
        });
        log.info("获取航线数量为："+list.size());

        Workbook wb = ExcelExportUtil.exportWorkbook(list);
        try {
            wb.write(response.getOutputStream());
        } catch (IOException e) {
            e.printStackTrace();
        }finally {
            try {
                wb.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return  RespEntity.success("成功");
    }

}
