package com.bjlt.spider.controller;

import com.bjlt.spider.entity.LogEntity;
import com.bjlt.spider.util.LogUtils;
import com.luyn.date.DatePattren;
import com.luyn.date.DateUtil;
import com.luyn.web.RespEntity;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;
import java.util.Date;


@RestController
@Slf4j
@RequestMapping(value = "/exportLog")
public class ExportLog {
    @Autowired
    private RedisTemplate<String,Object> redisTemplate;

    @Value("${ErrorLog}")
    private String errorLog;



    @RequestMapping(value = "export", method = RequestMethod.POST)
    public RespEntity log(@RequestBody  LogEntity logEntity) {
        try {
            LogUtils.setLogOutFile(errorLog, DateUtil.getFormatDate(new Date(), DatePattren.DATA_FORMAT_14),logEntity.getType());

            LogUtils.error(logEntity.getType(),logEntity.getMethedName()+logEntity.getMsg().replace("null",""));

        } catch (IOException e) {
            e.printStackTrace();
            return RespEntity.error("false");
        }
        return RespEntity.success("true");
    }

}
